#include	"Samp_Main.h"
#include	"Samp_Play.h"
#include	"Samp_Key.h"
#include	"Samp_Lib.h"

UINT SampledaPlay( STM_PLAY_CDDA *state_play_cdda, MSG_ID *msg, UC1 *now_mode,UC1 *end_mode )
{

	UC1					starttno;
	UC1					endtno;
	UC1					ercd;
	STM						rtcd;

	switch(*state_play_cdda){

		case	DA_TIME_PROC:

			/*------------------------/
				TvRg
			/------------------------*/
			if( *now_mode != *end_mode ){		/* TvRg */
				state_play_cdda = DA_MODE_CHG;
				return( RET_CODEN );
			}

			if( com.play_speed != Samp_play_speed ){		/* TvRg */
				state_play_cdda = DA_MODE_CHG;		/* TvRg*/
				return( RET_CODEN );
			}
			break;
		default:
			break;
	}
	return( SAMP_WAIT );
}



UC1 SampledaTimeTimer(void)
{
	ER		ercd;

	timer2navi_msg.tsk = TSK_SAMPLE;
	timer2navi_msg.cmd = MSG_Samp_STC_TIMER;
	return((UC1)ercd);
}

STM_PLAY_CDDA SampledaStateError( MSG_ID *msg ){


	switch(msg->sts){
		case	HMS_PLAYED				:
		default							:
			return( DA_END );
	}

}

STM		SampleStopInit(STM_Samp_STOPINIT *state, MSG_ID *msg )
{

	UC1	ercd;

	switch(*state){


		case	0:
		/*-------------------/
			TvRg
		/-------------------*/
			ercd = MediaHostClearBuffer();
			if(ercd != E_OK){
				err_code = NAVIERR_MSG_OVER_FE_TSK;
				return(SAMP_ERROR);
			}
			*state = 1;
			return(SAMP_WAIT);


		/*-------------------/
			TvRg
		/-------------------*/
		case	1:
			if(( msg->tsk == TSK_HOST ) && (msg->cmd == CLEAR_HOST )){
				if( msg->sts == HMS_GOOD ){
					tsk |= MAIN_TSK_SAMP1;
					if(DriveSts_formattype == FORMATTYPE_DTS){
					}
					if(ercd != E_OK){
						err_code = NAVIERR_MSG_OVER_AV_TSK;
						*state = 0;
						return(SAMP_ERROR);
					}
					*state = 2;			
					return(RET_CODEN);
				}else if(msg->sts == HMS_INVALID_CMD){
					MediaHostClearBuffer();
					return(SAMP_WAIT);
				}else{
					*state = 0;
					return(SAMP_ERROR);
				}
			}
			return(SAMP_WAIT);


		/*-------------------/
			TvRg
		/-------------------*/
		case	2:
			if(msg->tsk == TSK_SAMP1) {
				tsk &= ~MAIN_TSK_SAMP1;
				if(msg->sts == MESSAGE_GOOD){
				}else{
					*state = 0;
					return(SAMP_ERROR);
				}
			}
			return(SAMP_WAIT);

		case	3:
			if(msg->tsk == TSK_SAMP1) {
				tsk &= ~MAIN_TSK_SAMP1;
				if(msg->sts == MESSAGE_GOOD){
					*state = 0;
					return(SAMPLE_END); 
				}else{
					*state = 0;
					return(SAMP_ERROR);
				}
			}
			return(SAMP_WAIT);

		default	:
			break;
	}
	return(RET_CODEN);
}

void SampledaSetTime(SUBQ_FORM * subq)
{


	Samp_subq_adr = subq->ctrl_adr;
	Samp_subq_tno = subq->tno;
	Samp_subq_index = subq->index;

	Samp_time_min = subq->P.min;				/* TvRg 	*/
	Samp_time_sec = subq->P.sec;				/* TvRg 	*/
	Samp_time_frm = subq->P.frame;			/* TvRg	*/

	Samp_subq_amin = subq->A.min;				/* TvRg	*/
	Samp_subq_asec = subq->A.sec;				/* TvRg*/
	Samp_subq_afrm = subq->A.frame;			/*TvRg */
}


void SamDcdSetPlayMsf(USHORT trackno, UC1 m, UC1 s, UC1 f)
{
	UC1	min = BCD_CHG_BIN(GlobalTsttoc_time[trackno-1].min);
	UC1	sec = BCD_CHG_BIN(GlobalTsttoc_time[trackno-1].sec);
	UC1	frame = BCD_CHG_BIN(GlobalTsttoc_time[trackno-1].frame);
	
	min += BCD_CHG_BIN(m);
	sec += BCD_CHG_BIN(s);
	frame += BCD_CHG_BIN(f);
		
	Samp_dts_play_msf.min = BIN_CHG_BCD(min);
	Samp_dts_play_msf.sec = BIN_CHG_BCD(sec);
	Samp_dts_play_msf.frame = BIN_CHG_BCD(frame);

	if(trackno >= BCD_CHG_BIN(GlobalTsttoc_ltno)){
		CHAR	f = (CHAR)BCD_CHG_BIN(GlobalTsttoc_lout_time.frame);	/* TvRg */
		CHAR	s = (CHAR)BCD_CHG_BIN(GlobalTsttoc_lout_time.sec);		/* TvRg */
		CHAR	m = (CHAR)BCD_CHG_BIN(GlobalTsttoc_lout_time.min);		/* TvRg */

		Samp_dts_play_end_msf.min = BIN_CHG_BCD(m);
		Samp_dts_play_end_msf.sec = BIN_CHG_BCD(s);
		Samp_dts_play_end_msf.frame = BIN_CHG_BCD(f);
	}else{
		Samp_dts_play_end_msf.min = GlobalTsttoc_time[trackno].min;
		Samp_dts_play_end_msf.sec = GlobalTsttoc_time[trackno].sec;
		Samp_dts_play_end_msf.frame = GlobalTsttoc_time[trackno].frame;
	}
}



/*-----------------------------------------/
				TvRg
/-----------------------------------------*/
UC1 MainSamCdTrkCmd(UC1 media, UC1 mode)
{
	tsk |= MAIN_TSK_SAMP1;
		/* TvRg */
		/* TvRg*/

	if(media == FORMATTYPE_DTS){
		return(MainSamTrkplayDtscd(mode));
	}else{
		return(MainSamTrkplayCdda(mode));
	}
}

