#include	"Samp_Stop.h"
#include	"Samp_Main.h"
#include 	"Samp_Lib.h"

UINT  SampleStop(STM_Samp_STOP *sub_state_stop, MSG_ID *msg)
{

	switch( *sub_state_stop ){

		case	STM_Samp_STOP_PRE	:
			if(( msg->tsk == TSK_SAMP1 )){
				tsk &= ~MAIN_TSK_SAMP1;
				*sub_state_stop = STM_Samp_STOP_PRE2;
				return(SAMP_WAIT);
			}
			return( SAMP_WAIT );

		case	STM_Samp_STOP_PRE2	:
			if(( msg->tsk == TSK_HOST )&&( msg->cmd == CLEAR_HOST )){
				if( msg->sts == HMS_GOOD ){
					MainSamInidecMedia(AudioSts.sound, 0,  &setup ); 
					/* TvRg  */
					tsk |= MAIN_TSK_SAMP1;
					*sub_state_stop = STM_Samp_STOP_PRE4;
					return(SAMP_WAIT);
				}
			}
			return( SAMP_WAIT );

		case	STM_Samp_STOP_PRE4	:
			if(( msg->tsk == TSK_SAMP1 ) && ( msg->cmd == PROC_INITIAL_MEDIA )){
				tsk &= ~MAIN_TSK_SAMP1;
				*sub_state_stop = STM_Samp_STOP_INIT;
				return(RET_CODEN);
			}
			return(SAMP_WAIT);

		/*		TvRg */
		case	STM_MEDIA_STOP_AV	:
			if(( msg->tsk == TSK_SAMP1 ) && ( msg->cmd == PROC_STOPDEC_CDDA )){
				tsk &= ~MAIN_TSK_SAMP1;
				if( msg->sts == MESSAGE_GOOD ){
					MainSamInidecMedia(AudioSts.sound,0,  &setup); 
					/* TvRg  */
					tsk |= MAIN_TSK_SAMP1;
					*sub_state_stop = STM_MEDIA_INIT_AV;
					return(SAMP_WAIT);
				}
			}
			return( SAMP_WAIT );

		case	STM_DTSSamp_STOP_AV	:
			if(( msg->tsk == TSK_SAMP1 ) && ( msg->cmd == PROC_STOPDEC_DTSCD )){
				tsk &= ~MAIN_TSK_SAMP1;
				if( msg->sts == MESSAGE_GOOD ){
					*sub_state_stop = STM_Samp_STOP_FIN;
					return( RET_CODEN );
				}
			}
			return( SAMP_WAIT );
	}
	return(SAMP_WAIT);
}

