#include	"Samp_Main.h"
#include	"Samp_Play.h"
#include	"Samp_Key.h"
#include	"Samp_Lib.h"

void	SampledaCheckDiscKey( TEST_CMD *UserCmd )
{
	UC1			prohibit=0;
	
	/*  TvRg  */
	switch( UserCmd->cmd ){
		/*	TvRg   */
		case TEST_TITLE_PLAY:
			prohibit = SamplePlay((TEST_CMD*)UserCmd );		/*		TvRg	*/
			break;


		/*----------------------/
		TvRg
		/----------------------*/							/* TvRg	*/
		case TEST_NEXTPG_SEARCH:							/* TvRg */
			prohibit = SampleNextSearch();				/*	TvRg*/
			break;


		/*	TvRg */
		case TEST_PREVPG_SEARCH:							/* TvRg 	*/
			prohibit = SamplePrevSearch();				/*	TvRg	*/
			break;											/*	TvRg	*/


		/*	TvRg */
		case TEST_FORWARD_SCAN:									/* TvRg		*/
			prohibit = SampleTrick((TEST_CMD *)UserCmd);		/* TvRg		*/
			break;												/* TvRg		*/
																/* TvRg		*/

		/*	TvRg */
		case TEST_STOP:											/*	TvRg */

			prohibit = SampleStop();
			break;												/*	TvRg */



		/*	TvRg */
		case TEST_SM_TRAY_OPNCLS:								/*	TvRg */
			GlobalTstend_mode = TGT_DA_OPEN;					/*	TvRg */
			SamplePlayInfoUpdate(UNLOADING);					/*	TvRg */
			break;												/*	TvRg */


		/*	TvRg */
		/*	TvRg */
		case	TEST_TIME_SEARCH:
			prohibit = SampleTimeSearch((TEST_CMD *)UserCmd);		/*	*/
			break;

		/*	TvRg */
		case TEST_RESUME:
			SamplePlayMemory();
			break;

		/*	TvRg */
		case	TEST_SOUND_CHANGE:
			prohibit = SampleSound();			/*	TvRg */

			break;
		case	TEST_WIDE_CHANGE:		/*	TvRg */

			mTraceLog((LOG_NONE, "TEST_SET"));
			prohibit = SampleKaraoke();		
			break;

		default:
			break;
	}
}

UC1 SamplePlay( TEST_CMD *UserCmd )
{
	UC1	prohibit=0;

	/*	TvRg */
	if((UserCmd->argui < GlobalTststart_tno)||			/*	TvRg */
		(GlobalTstend_tno < UserCmd->argui)){			/*	TvRg */
		Prohibit();
		return(prohibit);								/*	TvRg */
	}													/*	TvRg */


	target_track = sprm[TRACK_TNO];					/*	TvRg */

	SampleDispTimeInit(0,0,0);
	if((com.play_cnd & PLAYER_PRC) == MEDIA_CND_PAUSE){		/*	TvRg */
		GlobalTstend_mode = TGT_MEDIA_PAUSE;				/*	TvRg */
		SamplePlayInfoUpdate(PAUSEACCESS);				/*	TvRg */
	}else{												/*  TvRg */
		GlobalTstend_mode = TEST_MEDIA_PLAY;				
		SamplePlayInfoUpdate(PLAY_ACCESS);				
	}
	return( prohibit );
}


UC1 SampleNextSearch(void)
{

	UC1	prohibit=0;


	if(GlobalTstnow_mode == NOW_MEDIA_STOP){
		return(prohibit);
	}

	if( sprm[TRACK_TNO] < GlobalTstend_tno ) {	
		sprm[TRACK_TNO]++;						
		target_track = sprm[TRACK_TNO];			

	}

	if ((com.play_cnd & PLAYER_PRC) == MEDIA_CND_PAUSE){		/* Rg1 */
		GlobalTstnow_mode = MEDIA_READY;				/* Rg1 */
		GlobalTstend_mode = TGT_MEDIA_PAUSE;				/* Rg1 */
		SampleDispTimeInit(0,0,0);						/* Rg1 */
		SamplePlayInfoUpdate(PAUSEACCESS);			/* Rg1 */
	}else{
		GlobalTstnow_mode = MEDIA_READY;					/* Rg1 */
		GlobalTstend_mode = TEST_MEDIA_PLAY;					/* Rg1 */
		SampleDispTimeInit(0,0,0);							/* Rg1 */
		SamplePlayInfoUpdate(PLAY);					/* Rg1 */
	}
	return(prohibit);
}

UC1 SamplePrevSearch(void)
{

	UC1	prohibit=0;

	if(GlobalTstnow_mode == NOW_MEDIA_STOP){
		return(prohibit);
	}

	if((MediPlay_minute == 0x00) && (MediPlay_sec == 0x00)){
		if( sprm[TRACK_TNO] > 1 ) {			
			sprm[TRACK_TNO]--;				
			target_track = sprm[TRACK_TNO];	
		}else{
			sprm[TRACK_TNO] = 1;			
			target_track = sprm[TRACK_TNO];	
		}
	}else{
		target_track = sprm[TRACK_TNO];		
	}


	if (GlobalTstend_mode == TGT_MEDIA_PAUSE){		
		GlobalTstnow_mode = MEDIA_READY;		
		GlobalTstend_mode = TGT_MEDIA_PAUSE;		
		SampleDispTimeInit(0,0,0);				
		SamplePlayInfoUpdate(PAUSEACCESS);		
	}else{
		GlobalTstnow_mode = MEDIA_READY;		
		GlobalTstend_mode = TEST_MEDIA_PLAY;		
		SampleDispTimeInit(0,0,0);				
		SamplePlayInfoUpdate(PLAY);				

	}
	return(prohibit);
}


UC1 SampleTrick( TEST_CMD *UserCmd)
{

	UC1	prohibit=0;


	if((com.play_cnd & PLAYER_PRC) < MEDIA_CND_ACCESS){	
		return(prohibit);							
	}

	if(GlobalTstnow_mode == MEDIA_READY){			
		return(prohibit);							
	}

	if((MediPlay.systemmode == FWDSEARCHACCESS) 
	|| (MediPlay.systemmode == BWDSEARCHACCESS)){	
		return(prohibit);							
	}

	switch(UserCmd->cmd){

		case	TEST_PAUSE_ON	:
			if(GlobalTstend_mode != GlobalTstnow_mode ){
				
			}else{
				GlobalTstend_mode = TGT_MEDIA_PAUSE;	
				Samp_play_cnd = PAUSE;
				Samp_play_speed = PSPEED_NORMAL;
			}
			break;

		case	TEST_PAUSE_OFF	:
			GlobalTstend_mode = TEST_MEDIA_PLAY;
			Samp_play_cnd = PLAY;
			Samp_play_speed = PSPEED_NORMAL;
			break;

		case	TEST_FORWARD_SCAN	:
			if ((com.play_cnd & PLAYER_PRC) == MEDIA_CND_PAUSE){	
				GlobalTstend_mode = TGT_MEDIA_SCANP;			
				Samp_play_speed = UserCmd->argui;			

			}else if(com.play_cnd == MEDIA_CND_PLAY){
				GlobalTstend_mode = TGT_MEDIA_SCAN;			
				Samp_play_speed = UserCmd->argui;			
			}else{
				if(UserCmd->argui != 0){
					GlobalTstend_mode = TGT_MEDIA_SCAN;		
					Samp_play_speed = UserCmd->argui;		
				}else{
					GlobalTstend_mode = TEST_MEDIA_PLAY;	
				}
			}
			Samp_play_cnd = FWDSEARCH;
			break;

		case	TEST_BACKWARD_SCAN	:
			if ((com.play_cnd & PLAYER_PRC) == MEDIA_CND_PAUSE){	
				GlobalTstend_mode = TGT_MEDIA_SCANP;			
				Samp_play_speed = UserCmd->argui;			
				SamplePlayInfoUpdate(BWDSEARCHACCESS);		
			}else{
		 		GlobalTstend_mode = TGT_MEDIA_SCAN;			
				Samp_play_speed = UserCmd->argui;			
				SamplePlayInfoUpdate(BWDSEARCHACCESS);		
			}
			Samp_play_cnd = BWDSEARCH;
			break;

	}
	return(prohibit);
}


UC1 SampleStop(void)
{

	UC1	prohibit=0;
	
	switch(GlobalTstnow_mode){

		case	NOW_MEDIA_STOP:
			if(Samp_memory_mode == Samp_RESUME_ON){		
				Samp_memory_mode = Samp_RESUME_CLEAR;
				SamplePlayInfoUpdate(STOP);				
			}
			break;
		
		case	NOW_DA_PLAY:
		case	NOW_DA_PAUSE:
			if(i_mode.main == IFMODE_PROGRAM){
				SamplePlayInfoUpdate(STOP);			
			}else{
				SamplePlayInfoUpdate(RSM_STOP);		
				Samp_memory_mode = Samp_RESUME_ON;
				SampleSetMemory( sprm[4], MediPlay_minute, MediPlay_sec, MediPlay_frame );
			}
			GlobalTstend_mode = TGT_DA_STOP;	
			break;

		case	0xFF:
			GlobalTstend_mode = TGT_DA_STOP;	
			break;

		default:
			GlobalTstend_mode = TGT_DA_STOP;	
			SamplePlayInfoUpdate(STOPACCESS);	
			SampleSetMemory( sprm[4], MediPlay_minute, MediPlay_sec, MediPlay_frame );
			break;
	}
	return(prohibit);
}

UC1 SampleKaraoke(void)
{

	UC1	prohibit=0;
	
	switch(GlobalTstnow_mode){
		default:
			GlobalTstend_mode = TGT_DA_KARAOKE;		
			break;
	}
	return(prohibit);
}

UC1 SampleSound(void)
{

	UC1	prohibit=0;
	
	switch(GlobalTstnow_mode){
		default:
			GlobalTstend_mode = TGT_SOUND_CHG;		
			break;

	}
	return(prohibit);
}

UC1 SampleTimeSearch(TEST_CMD *UserCmd)
{

	UC1	prohibit=0;
	ULONG	tsearch_lsn=0;
	UC1	i=0;
	ULONG	lout_lsn;

	if(GlobalTstnow_mode == NOW_MEDIA_STOP){
		tsearch_lsn = (ULONG)(((ULONG)(UserCmd->time.min * 60) + UserCmd->time.sec ) * 75);
		lout_lsn = Msf2Lba(&GlobalTsttoc_lout_time);
		if(lout_lsn < tsearch_lsn){									
			Prohibit();										
			return(1);	
		}else if(tsearch_lsn < Msf2Lba(&GlobalTsttoc_time[0])){		
			Prohibit();										
		}else{
			if(tsearch_lsn >= Msf2Lba(&GlobalTsttoc_time[BCD_CHG_BIN(GlobalTsttoc_ltno)-1])){
				i = BCD_CHG_BIN(GlobalTsttoc_ltno);
				Samp_tsearch.end_msf = GlobalTsttoc_lout_time;
			}else{
				while(tsearch_lsn > Msf2Lba(&GlobalTsttoc_time[i])){
					i++;
				}
				Samp_tsearch.end_msf = GlobalTsttoc_time[i];
			}
			Samp_tsearch_mode = 1;
			GlobalTstend_mode = TEST_MEDIA_PLAY;
			Samp_play_cnd = PLAY_ACCESS;

			SamplePlayInfoUpdate(PLAY_ACCESS);
			Samp_tsearch.start_msf.min = UserCmd->time.min;
			Samp_tsearch.start_msf.sec = UserCmd->time.sec;
			target_track = i;
			sprm[TRACK_TNO] = i;
			SamplePlayInfoUpdate(Samp_play_cnd);
		}

	}else if(UserCmd->titlenum == 0xFF){
		Samp_time_min = UserCmd->time.min;
		Samp_time_sec = UserCmd->time.sec;

		Samp_tsearch_mode = 1;
		GlobalTstend_mode = TEST_MEDIA_PLAY;
		GlobalTstnow_mode = MEDIA_READY;	
		Samp_play_cnd = PLAY_ACCESS;		
		Samp_da_pause_req = 0;
		sprm[TRACK_TNO] = UserCmd->pttn;
		Samp_play_cnd = PLAY_ACCESS;						
		Samp_play_speed = 0;

	}else{
		tsearch_lsn = ((ULONG)((ULONG)(UserCmd->time.min * 60) + UserCmd->time.sec) * 75)
					+ Msf2Lba(&GlobalTsttoc_time[UserCmd->pttn - 1]);
		if(UserCmd->pttn >= GlobalTstend_tno){
			lout_lsn = Msf2Lba(&GlobalTsttoc_lout_time);
			Samp_tsearch.end_msf = GlobalTsttoc_lout_time;
		}else{
			lout_lsn = Msf2Lba(&GlobalTsttoc_time[UserCmd->pttn]);
			Samp_tsearch.end_msf = GlobalTsttoc_time[UserCmd->pttn - 1 ];
		}
		if(lout_lsn - 80 < tsearch_lsn){
			Prohibit();					
			return(1);
		}else{
			Samp_time_min = BIN_CHG_BCD(UserCmd->time.min);
			Samp_time_sec = BIN_CHG_BCD(UserCmd->time.sec);
			SamDcdSetPlayMsf((USHORT)UserCmd->pttn, BIN_CHG_BCD(UserCmd->time.min), BIN_CHG_BCD(UserCmd->time.sec), 0x74);
			Samp_tsearch.start_msf.min = Samp_dts_play_msf.min;	
			Samp_tsearch.start_msf.sec = Samp_dts_play_msf.sec;	
			Samp_tsearch.end_msf.min = Samp_dts_play_end_msf.min;
			Samp_tsearch.end_msf.sec = Samp_dts_play_end_msf.sec;

			Samp_da_pause_req = 0;
			Samp_tsearch_mode = 1;							
			GlobalTstend_mode = TEST_MEDIA_PLAY;				
			GlobalTstnow_mode = MEDIA_READY;				
			Samp_play_cnd = PLAY_ACCESS;					
			sprm[TRACK_TNO] = UserCmd->pttn;
			Samp_play_cnd = PLAY_ACCESS;					
			Samp_play_speed = 0;
		}

	}
	return(prohibit);
}


void SampleSetMemory(UC1 tno, UC1 min, UC1 sec, UC1 frame)
{

	MSF_TBL		msf;
	UC1		min2;
	UC1		sec2;
	UC1		frm2;
	
	Samp_memory_msf[0].trackno = tno;	

	min2 = BCD_CHG_BIN(GlobalTsttoc_time[tno-1].min) + BCD_CHG_BIN(min);
	sec2 = BCD_CHG_BIN(GlobalTsttoc_time[tno-1].sec) + BCD_CHG_BIN(sec);
	frm2 = BCD_CHG_BIN(GlobalTsttoc_time[tno-1].frame) + BCD_CHG_BIN(frame);
	
	if(frm2 >= 75){
		frm2 -= 75;
		sec2++;
	}
	if(sec2 >= 60){
		sec2 -= 60;
		min2++;
	}

	Samp_memory_msf[0].msf.min = BIN_CHG_BCD(min2);
	Samp_memory_msf[0].msf.sec = BIN_CHG_BCD(sec2);
	Samp_memory_msf[0].msf.frame = BIN_CHG_BCD(frm2);

	if(tno >= BCD_CHG_BIN(GlobalTsttoc_ltno)){
		if(GlobalTsttoc_lout_time.frame == 0){
			msf.frame = 74;
			if(GlobalTsttoc_lout_time.sec == 0){
				msf.sec = 59;
				msf.min = GlobalTsttoc_lout_time.min - 1;
			}else{
				msf.sec = GlobalTsttoc_lout_time.sec - 1;
				msf.min = GlobalTsttoc_lout_time.min;
			}
		}else{
			msf.frame = GlobalTsttoc_lout_time.frame-1;
			msf.sec = GlobalTsttoc_lout_time.sec;
			msf.min = GlobalTsttoc_lout_time.min;
		}
		Samp_memory_end_msf[0].msf.min = msf.min;
		Samp_memory_end_msf[0].msf.sec = msf.sec;
		Samp_memory_end_msf[0].msf.frame = msf.frame;
	}else{
		Samp_memory_end_msf[0].msf = GlobalTsttoc_time[tno];
	}
}


void SamplePlayMemory(void)
{

	if(Samp_memory_mode == Samp_RESUME_ON){
		Samp_memory_mode = Samp_RESUME_PLAY;		

		sprm[TRACK_TNO] = Samp_memory_msf[0].trackno;
		target_track = Samp_memory_msf[0].trackno;

		GlobalTstend_mode = TEST_MEDIA_PLAY;
		SamplePlayInfoUpdate(PLAY_ACCESS);
		Samp_play_speed = PSPEED_NORMAL;
	}
}


